﻿function [p,Lp]=GammaG(x,th)
  // gamma proximity  (for scalar variable)
  //   f(x) = (b^a/Gamma(a)) * x^(a-1) * exp(-bx)
  // uspořádání th
  // koef    a         b 
  // y(1)    th(1,1)   th(1,2)
  // y(2)    th(2,1)   th(2,2)
  Lp=0;
  for i=1:length(x) // cyklus přes data (jedna komponenta)
    Lp=Lp+(th(i,1)-1)*log(x(i))-th(i,2)*x(i)+..
       th(i,1)*log(th(i,2))-gammaln(th(i,1));
  end         
  p=exp(Lp);
endfunction

  
