﻿// ini1Oblast.sce
// Určení oblasti dat
// ------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion

nd=100;             // počet dat
for t=1:nd
  y(:,t)=[5;3;8]+[2;1;3].*rand(3,1,'n');
end

mi=min(y,'c');
ma=max(y,'c');

nc=5;               // počet komponent
for i=1:nc
  thI(:,i)=(mi+ma)/2+.2*(ma-mi).*rand(3,1,'n');
end

scf();
plot(y(1,:),y(2,:),'b.')
plot(thI(1,:),thI(2,:),'ro','markersize',12)
title 'Centers for the first two variables'
