﻿// ini5Opak.sce
// Opakovaný odhad na stejných datech
// ------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion

nd=10;
k=[2; -1]; sd=.01;

for t=1:nd
  y(:,t)=k+sd*rand(2,1,'n');
end

// Inicializace k prvnímu odhadu
kk=[-5;8];                    // poč. hodnota par. je kk
V0(1:2,1:2)=kk*kk'; 
V0(3,1:2)=kk'; V0(1:2,3)=kk; V0(3,3)=1; // nastavení V
V0=V0*10; V=V0;               // V schválně trochu fixujeme - V0=V0*10

// První odhad
for t=1:nd
  Ps=[y(:,t)' 1]';
  V=V+Ps*Ps';
  Vy=V(1:2,1:2);
  Vyp=V(3:$,1:2);
  Vp=V(3:$,3:$);
  th=inv(Vp+1e-12*eye(Vp))*Vyp;
  th1(:,t)=th';               // vývoj odhadů v první fázi
end
th1=[kk th1];                 // z výchozího odhadu kk se dále odhaduje

fi=50;     // Zkuste fi=1,10,50
V=V/fi;   // ZAPOMENUTÍ (uvolnění odhadu pro další postup) 
// Druhý odhad na stejných datech
for t=1:nd
  Ps=[y(:,t)' 1]';
  V=V+Ps*Ps';
  Vy=V(1:2,1:2);
  Vyp=V(3:$,1:2);
  Vp=V(3:$,3:$);
  th=inv(Vp+1e-12*eye(Vp))*Vyp;
  th2(:,t)=th';                     //  vývoj odhadů v druhé fázi
end

// Výsledky
scf();
plot(th1(1,:),th1(2,:),'.:')       // první odhad
plot(th2(1,:),th2(2,:),'.:g')      // druhý odhad
plot(2,-1,'ro','markersize',12)    // správná hodnota paramrtru k
set(gca(),'data_bounds',[-6 4 -2 9])
title 'Vývoj odhadu konstanty - b=1.odhad. g=2.odhad'  
