function ps=genps(n,t,y,u,ips)
  // ps=genps(n,t,y,u)    generation of regression vector \psi
  //                        i.e. without y(t)
  // n    order
  // t    time
  // y    output
  // u    input
  // ips  indicator of ps ordering 1(def)=u,y,uy, 2=y,y,u,u,u

  if argn(2)<5, ips=1; end

  if ips==1                   // alt strust of ps
    ps=u(:,t);
    for i=1:n
      ps=[ps; y(:,t-i); u(:,t-i)];
    end
  else                        // firs y then u
    ps=[];
    for i=1:n
      ps=[ps; y(:,t-i)];
    end
    for i=0:n
      ps=[ps; u(:,t-i)];
    end
  end
  ps=[ps; 1];
endfunction
