function ps=getps(dim,dt)
  // ps=getps(dim,dt)   create (short) regression vector
  // dim     dimensions
  // dt      data
  // ps      reg.vect. [u(t),v(t),y(t-1),u(t-1),v(t-1),...,1];

  t=dt.t;
  str=dim.str;
  nps=dim.nps;

  ps=zeros(1,nps);
  for i=1:(nps-1)
                                        // pause
    ps(i)=dt.d(str(1,i),t-str(2,i));
  end
  if str(1,$)==0, ps($)=1; end
endfunction
