function lL=lrLikN(b0,y,x)
// lL=lrLikN(b,y,x)   log-likelihood of logistic regression
//                     with multivariate y (y must start by 0)
//                     Serves as verification of liglikMLR
b=matrix(b0,size(x,2)+1,max(y));

[n m]=size(x);
K=max(y);
x1=[ones(n,1) x];
ny=zeros(1,K+1);
logL=0;
                     //   pause
for i=1:n
  z=x1(i,:)*b;
  ez=exp(z);
  sz=1+sum(ez,2);
  p=ez./sz;
  p0=1/(1+sum(ez,2));
  j=y(i);
  if j==0
    logL=logL+log(p0);
  else 
    logL=logL+log(p(j));
  end
end
lL=-logL;

//[n m]=size(x);
//x1=[ones(n,1) x];
//lL=0;
//        pause
//for i=1:n
//  z=x1(i,:)*b; 
//  pp=[0 z]-log(1+sum(exp(z),1));
//  lL=lL+pp(y(i)+1);
//end
//logL=-lL;
endfunction
