function i=psi2row(x,b)
  // i=psi2row(x,b)  i is row number of a model table with 
  //                 the regression vector x with the base b;
  //                 elements of x(i) are 1,2,...,nb(i) 
  // it is based on the relation
  //     i=b(n-1)b(n-2)...b(1)(x(n)-1)+...+b(1)(x(2)-1)+x(1)

  n=length(x);
  if argn(2)<2, b=2*ones(1,n); end
  bb=b(2:n);
  bb=bb(:)';
  b=[bb 1];
  i=0;
  for j=1:n
    i=(i+x(j)-1)*b(j);
  end
  i=i+1;
endfunction
