﻿// ini2IniPar.sce
// Počáteční odhady parametrů a k nim statistiky
// ------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion
rand('seed',0)

nd=500;             // number of data
I_estCov=0;         // estimation of noise covariances ? 0|1 no|yes

// simulated reg.coef.
Cy(1).th=[1 2 4]';
Cy(2).th=[5 3 2]';
Cy(3).th=[2 5 6]';
Cy(4).th=[3 8 8]';
nc=length(Cy);
nc=nc;
// simulated noise covariances
for i=1:4
  rn=rand(3,3,'u');
  Cy(i).cv=.2*(eye(3,3)+rn+rn');
end
// simulated pointer parameters
Cp.th=fnorm(ones(1,3)+.1,2);

ct(1)=1;                  // initial poiner
// SIMULATION ==========================================================
for t=1:nd
  ct(1,t)=sum(rand(1,1,'u')>cumsum(Cp.th))+1;    // pointer
  j=ct(t); // active component
  y=Cy(j).th+uut(Cy(j).cv)*rand(3,1,'norm');        // output
  yt(:,t)=y;
end   

ii=[2 3 6];
set(scf(),'position',[600 100 800 600])
for i=1:2
  for j=i+1:3
    subplot(3,3,3*(i-1)+j)
    plot(yt(i,:),yt(j,:),'.')
  end
end
