function [ct,md]=lrTestU(x,Est,al)
  // ct=lrTest(x,Est,al)      test data with model from "lrLearn"
  //                          Mixture logistic regressiom
  // x    tested data item
  // Est  estimation structure  Est.th, Est.cv
  // al   stationary komponents probabilities
  // ct   estimated class labels

  nc=max(size(Est));
  nd=size(x,1);
  md=zeros(nc,nd);
  for t=1:nd
    xt=x(t,:);
    b=unifdst(xt,Est);
    mm=b.*al;
    sm=sum(mm);
    for c=1:nc
      if sm>0
        mq(c)=mm(c)/sm;
      else
        mq(c)=%nan;
      end
    end
    md(:,t)=mq;
  end
  [xxx ct]=max(md,'r');
endfunction
